import "bootstrap";
import "../sass/main.scss";
import "owl.carousel/dist/assets/owl.carousel.css";
import "owl.carousel/dist/assets/owl.theme.default.css";
import "owl.carousel";
import fullpage from "fullpage.js";
import "select2";

import navigation from './navigation';
import home from './home';
import clients from './clients';
import modal from './modal';


(function (  )
{
  'use strict';

  $(document).ready(function()
  {
    // moduls
    var navigationModul = new navigation();
    var homeModul = new home();

    var clientsModul = new clients();
    clientsModul.init();

    var modalModul = new modal();
    modalModul.init();



    // preloader
    homeModul.hidePreloader();
    navigationModul.showNavi();











    // stop animations and transitions on windows resizing
    let resizeTimer;
    window.addEventListener("resize", () => {
      document.body.classList.add("resize-animation-stopper");
      clearTimeout(resizeTimer);
      resizeTimer = setTimeout(() => {
        document.body.classList.remove("resize-animation-stopper");
      }, 400);
    });

    // DEBUG
    $(window).on('resize', function(){
      var winWidth = $(window).width();
      var winHeight = $(window).height();
      $("#debug").html(winWidth + " / " + winHeight);
    });
    $(window).resize();


    // fullpage.js
    new fullpage("#fullpage", {
      licenseKey: "CB5C6546-015A4724-B444D532-033B7856",
      anchors: ["home", "mission", "customers", "speed", "about", "contact"],
      paddingTop: "35px",
      autoScrolling: true,
      scrollingSpeed: 1000, // 400
      fitToSectionDelay: 400,
      responsiveHeight: 600,
      lazyLoading: true,
      scrollBar: false,
      scrollOverflow: false,
      onLeave: function(origin, destination, direction)
      {
        //console.log("fullpage.onLeave() : " + destination.index);

        // video: play/pause
        if(destination.index == 0)
        {
          homeModul.playVideo();
        }
        else
        {
          homeModul.pauseVideo();
        }

        // navi: open/close
        if (direction == "up" && destination.index > 0)
        {
          navigationModul.openNavi();
        }
        else
        {
          navigationModul.closeNavi();
        }
        //console.log("fullpage.onLeave() : "  + origin.index + " / " + destination.index + " // " + direction);

        // sidebar: hide
        if(destination.index == 1 || destination.index == 2 || destination.index == 3)
        {
          $(".sidebar").removeClass("show");
        }
      },
      afterLoad: function(origin, destination, direction){
        var loadedSection = this;

        //console.log("fullpage.afterLoad() : "  + origin.index + " / " + destination.index + " // " + direction);

        // sidebar: show
        if(destination.index == 0 || destination.index == 4 || destination.index == 5)
        {
          $(".sidebar").addClass("show");
        }
      }
    });





    // form
    $(function() {
      // handle contact form
      $("#form_submit").click(function() {
        var salutation = $("#form_salutation").val();
        var name = $("#form_name").val();
        var company = $("#form_company").val();
        var position = $("#form_position").val();
        var phone = $("#form_phone").val();
        var email = $("#form_email").val();
        var message = $("#form_message").val();
        $("#form_returnmessage").empty(); // empty previous error/success message.
        // Checking for blank fields.
        if (
          salutation == "" ||
          name == "" ||
          company == "" ||
          position == "" ||
          phone == "" ||
          email == "" ||
          message == ""
        ) {
          alert("Bitte füllen Sie alle Felder aus.");
        } else {
          // Returns successful data submission message when the entered information is sent successfully via mail.
          $.post(
            "php/contact_form.php",
            {
              name1: name,
              email1: email,
              message1: message,
              contact1: contact
            },
            function(data) {
              $("#form_returnmessage").append(data); // Append returned message to message paragraph.
              if (data == "success") {
                $("#form")[0].reset(); // To reset form fields on success.
              }
            }
          );
        }
      });

      // handle main nav toggler
      $("#toggle").click(function() {
        if ($(this).hasClass("active")) {
          $("#mainNav").addClass("closing");

          setTimeout(function() {
            $("#toggle").removeClass("active");
            $("#mainNav").removeClass("open");
            $(".logo").removeClass("nav_is_open");
            $("#mainNav").removeClass("closing");
          }, 1300);
        } else {
          $(this).addClass("active");
          $("#mainNav").addClass("open");
          $(".logo").addClass("nav_is_open");
        }
      });

      // handle main nav link should close nav overlay
      $("#mainNav li a").on("click", function() {
        $("#toggle").trigger("click");
      });

      // init select2 plugin for <select></select> tags
      $("select.form-control").select2({
        minimumResultsForSearch: Infinity
      });
    });


  });
})();




